<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { generateLayoutMeta, getPageMetadata } from '~/common/meta';
import { NAV_CONTENT_TYPES } from '../common/content-types';
import { convertToCaseSensitiveLocale } from '../common/util';
import { MarketoFormPageService } from '~/services';
import { getNavigationClient } from '~/plugins/contentful';
import { CtfPage } from '~/models';
import { AosAnimationsMixin, LocalizedHrefMixin } from '../mixins';
import {
  MarketoFormPageHOC,
  SlpNavigationHOC,
} from '../components/navigation/index.vue';
import {
  MarketoFormPageContentCards,
  MarketoFormPageHero,
  MarketoFormPageLogos,
  MarketoFormWrapper,
} from '~/components/marketo-form-page/index.vue';

export default Vue.extend({
  components: {
    SlpNavigationHOC,
    MarketoFormPageHOC,
    MarketoFormWrapper,
    MarketoFormPageHero,
    MarketoFormPageContentCards,
    MarketoFormPageLogos,
  },
  mixins: [LocalizedHrefMixin, AosAnimationsMixin],
  data() {
    return {
      footer: {},
      content: null,
      submitted: false,
      path: null,
    };
  },
  async fetch() {
    this.path = this.$route.path.startsWith('/')
      ? this.$route.path.slice(1)
      : this.$route.path;
    try {
      const content: CtfPage = await (<MarketoFormPageService>(
        this.$marketoFormPageService
      )).getContent(`${this.path}`);
      const footerEntry = await getNavigationClient().getEntries({
        content_type: NAV_CONTENT_TYPES.FOOTER,
        'sys.id': 'QxdoqHd5ixKTwFjIHYvYI',
        include: 3,
        locale: convertToCaseSensitiveLocale(this.$i18n.locale),
      });
      const [footer] = footerEntry.items;
      this.footer = footer;
      this.content = content;
    } catch (e) {
      throw new Error(e);
    }
  },

  head(): MetaInfo {
    const metadata = getPageMetadata(
      this.content || {},
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
    const layoutMeta = generateLayoutMeta(this.$route.path, this.$i18n.locale);

    return {
      ...metadata,
      link: [...metadata.link, ...layoutMeta.link],
      htmlAttrs: { ...layoutMeta.htmlAttrs },
    } as MetaInfo;
  },
  beforeMount() {
    this.validateIndexFiles();
  },
  methods: {
    validateIndexFiles() {
      if (this.$route.path.endsWith('index.html')) {
        const queryParams = this.$route.query;
        const oldPath = this.$route.path.replace(/(\W*index\.html\W*)/g, '');
        this.$router.replace({
          path: `${oldPath}/`,
          query: queryParams,
        });
      }
    },
    onFormSubmit() {
      this.submitted = !this.submitted;
    },
  },
});
</script>

<template>
  <div>
    <SlpNavigationHOC v-show="submitted" key="slp-nav" />
    <MarketoFormPageHOC
      v-show="!submitted"
      key="min-nav"
      entry-id="7l7pMrsEsO6rao2j1zINTq"
    />
    <section ref="localizedContainer" role="main">
      <div ref="targetRef" class="marketo-form-page">
        <MarketoFormPageHero
          v-if="content?.hero"
          :hero="content?.hero"
          :form="content?.form"
          :submitted="submitted"
        />
        <SlpContainer v-if="!submitted" class="marketo-form-page__wrapper">
          <SlpRow>
            <SlpColumn data-aos="fade-up" data-aos-duration="750" :cols="6">
              <div class="marketo-form-page__content">
                <div
                  v-if="content?.headerAndText"
                  class="marketo-form-page__text-block"
                >
                  <SlpTypography
                    v-if="content?.headerAndText?.fields?.text"
                    tag="div"
                    variant="body2"
                    class="slp-mt-48"
                  >
                    <div
                      v-html="$md.render(content?.headerAndText?.fields?.text)"
                    ></div>
                  </SlpTypography>
                </div>
                <MarketoFormPageContentCards :cards="content?.cards" />
              </div>
            </SlpColumn>

            <SlpColumn :cols="6">
              <MarketoFormWrapper
                v-if="content?.form && !submitted"
                data-aos="fade-up"
                data-aos-duration="750"
                :data="content?.form"
                class="marketo-form-page__form"
                @submit="onFormSubmit"
              />
            </SlpColumn>
          </SlpRow>
        </SlpContainer>
        <MarketoFormPageLogos
          v-if="content?.logos && submitted"
          :data="content?.logos"
        />
      </div>
    </section>
    <client-only>
      <SlpMinimizedFooter
        :contentful-footer-data="footer"
        class="marketo-form-page__footer"
      />
    </client-only>
  </div>
</template>

<style lang="scss" scoped>
.marketo-form-page {
  overflow: hidden;
  &__form {
    margin-top: -112px;
    margin-bottom: 64px;
    @media (min-width: $breakpoint-md) {
      margin-bottom: 96px;
    }
  }
  &__content {
    margin-bottom: 64px;
    @media (min-width: $breakpoint-md) {
      margin-right: 84px;
      margin-bottom: 96px;
    }
  }
  &__text-block {
    &:deep(ul) {
      padding-left: 32px;
      margin: 16px 0;

      li {
        margin-top: 8px;
        position: relative;

        &:before {
          content: url('/nuxt-images/icons/list-check-dark.svg');
          position: absolute;
          top: 3px;
          left: -30px;
        }
      }
    }
  }
  :deep .code-suggestions-sales-form-wrapper__blurb {
    p:first-of-type {
      margin-top: 0 !important;
      strong {
        font-family: 'GitLab Sans';
        font-size: 16px;
        font-weight: 600;
        line-height: 24px;
        text-align: left;
        margin-top: 0;
      }
    }
  }
  &__footer {
    :deep {
      .be-nav-minimal-footer__navigation {
        display: flex;
        @media (min-width: $breakpoint-md) {
          flex-direction: row;
        }
      }
      .slp-col-md-10 {
        @media (min-width: $breakpoint-md) {
          max-width: 800px;
        }
      }
    }
  }
}
</style>
